Bug 971244 - Review Request: adevs - C++ library for constructing discrete event simulation
Summary: Review Request: adevs - C++ library for constructing discrete event simulation
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
(Show other bugs)
Version: rawhide
Hardware: All Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
Jaroslav Škarvada
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-06-06 06:24 UTC by Jan Kaluža
Modified: 2013-06-29 18:13 UTC (History)
3 users (show)

Fixed In Version: adevs-2.6-4.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-06-27 02:04:21 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jskarvad: fedora-review+
limburgher: fedora-cvs+


Attachments (Terms of Use)

Description Jan Kaluža 2013-06-06 06:24:15 UTC
Spec URL: http://jkaluza.fedorapeople.org/adevs.spec
SRPM URL: http://jkaluza.fedorapeople.org/adevs-2.6-1.fc18.src.rpm
Description: Adevs (A Discrete EVent System simulator) is a C++ library for constructing discrete event simulations based on the Parallel DEVS and Dynamic DEVS (dynDEVS) formalism.
Fedora Account System Username: jkaluza

Comment 1 Jan Kaluža 2013-06-06 07:47:01 UTC
Btw, I already sent email upstream about incorrect-fsf-address rpmlint error. According to http://fedoraproject.org/wiki/Common_Rpmlint_issues#incorrect-fsf-address, it is the only thing I have to do with this error.

Comment 2 Jaroslav Škarvada 2013-06-11 11:01:53 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v2 or later)", "LGPL (v2 or later) (with incorrect FSF address)",
     "Unknown or generated". 306 files have unknown license. Detailed output
     of licensecheck in /var/tmp/review/971244-adevs/licensecheck.txt

In the source code there are LGPLv2+, but the SPEC has GPLv2+


[-]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Maven:
[-]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[?]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.

You could do it.

[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.

I tried only to run the included tests, but they don't compile:
g++ -fopenmp -g -pedantic -Wall -I../include atomic_test.cpp 
In file included from ../include/adevs.h:30:0,
                 from atomic_test.cpp:3:
../include/adevs_simulator.h: In instantiation of ‘void adevs::Simulator<X, T>::exec_event(adevs::Atomic<X, T>*, bool, T) [with X = char; T = double]’:
../include/adevs_simulator.h:338:3:   required from ‘void adevs::Simulator<X, T>::computeNextState(adevs::Bag<adevs::Event<X, T> >&, T) [with X = char; T = double]’
atomic_test.cpp:118:32:   required from here
../include/adevs_simulator.h:620:2: error: ‘notify_state_listeners’ was not declared in this scope, and no declarations were found by argument-dependent lookup at the point of instantiation [-fpermissive]
../include/adevs_simulator.h:620:2: note: declarations in dependent base ‘adevs::AbstractSimulator<char, double>’ are not found by unqualified lookup
../include/adevs_simulator.h:620:2: note: use ‘this->notify_state_listeners’ instead
make: *** [atomic] Error 1

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.

Patch is not justified by comment, but it's purpose is clear. I think you
could improve it a bit (i.e. conditionalize the modelica) and get it upstream.
Also you don't need to comment out the OPTFLAG, just run 'make OPTFLAG=',
the same for java, so you could stay more close to the upstream.

[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.

You could run the tests.

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Java:
[-]: Packages are noarch unless they use JNI
     Note: adevs subpackage is not noarch. Please verify manually
[-]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: adevs-2.6-1.fc18.x86_64.rpm
          adevs-devel-2.6-1.fc18.x86_64.rpm
adevs.x86_64: W: spelling-error %description -l en_US dynDEVS -> dynasty
adevs-devel.x86_64: W: spelling-error %description -l en_US dynDEVS -> dynasty
adevs-devel.x86_64: W: no-documentation
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/object_pool.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_simulator.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_abstract_simulator.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_simpledigraph.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_event_listener.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp_graph.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_poly.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_msg_manager.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_par_simulator.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_time.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_exception.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_cellspace.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_message_q.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_sched.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_bag.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_set.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_models.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp_no_omp.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_wrapper.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp_omp.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_digraph.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_rand.h
2 packages and 0 specfiles checked; 24 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint adevs-devel adevs
adevs-devel.x86_64: W: spelling-error %description -l en_US dynDEVS -> dynasty
adevs-devel.x86_64: W: no-documentation
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/object_pool.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_simulator.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_abstract_simulator.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_simpledigraph.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_event_listener.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp_graph.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_poly.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_msg_manager.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_par_simulator.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_time.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_exception.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_cellspace.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_message_q.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_sched.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_bag.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_set.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_models.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp_no_omp.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_wrapper.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_lp_omp.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_digraph.h
adevs-devel.x86_64: E: incorrect-fsf-address /usr/include/adevs/adevs_rand.h
adevs.x86_64: W: spelling-error %description -l en_US dynDEVS -> dynasty
2 packages and 0 specfiles checked; 24 errors, 3 warnings.
# echo 'rpmlint-done:'



Jar and class files in source
-----------------------------
./adevs-2.6/examples/java_life/CellSpace.class
./adevs-2.6/examples/java_life/Display.class
./adevs-2.6/examples/java_life/Life.class
./adevs-2.6/examples/java_life/Cell.class


Requires
--------
adevs-devel (rpmlib, GLIBC filtered):
    adevs(x86-64)
    libadevs.so.2()(64bit)

adevs (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
adevs-devel:
    adevs-devel
    adevs-devel(x86-64)

adevs:
    adevs
    adevs(x86-64)
    libadevs.so.2()(64bit)



Source checksums
----------------
http://www.ornl.gov/~1qn/adevs/adevs.tar.gz :
  CHECKSUM(SHA256) this package     : cedec6d73e0749a97f7f5cbc42aba01be06ae67aa40ab55e9178e700433fc069
  CHECKSUM(SHA256) upstream package : cedec6d73e0749a97f7f5cbc42aba01be06ae67aa40ab55e9178e700433fc069


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-18-x86_64
Command line :/usr/bin/fedora-review -b 971244


More comments:

CR + LF line ends in some files, e.g.: /src/Makefile and more

Please package doc and examples.

Could you run the tests?

There should be 'formalisms' instead of 'formalism' in the description as upstream has.

You could write in the description of the development package that it could be used for development or something similar. I think it is not good to have there the same description as the base package has.

You can add one more sentence to the desription (copy from the upstream description). 

Why openmp is not used? I think it can bring some performance gain and should be generally harmless.

Please do not mix macros and variables, i.e. $RPM_OPT_FLAGS and e.g. %{buildroot}. This is not against guidelines (IIRC), but you could be consistent, i.e. use %{optflags} instead of $RPM_OPT_FLAGS.

Please report the incorrect FSF address upstream.

You could also package java (if you want :).

There is various bundled js code in /docs/api/jquery.js under various licenses that doesn't seem to be compatible with LGPLv2+ (this is currently not packaged, but could be as the doc).

Comment 3 Jan Kaluža 2013-06-13 07:52:37 UTC
Spec URL: http://jkaluza.fedorapeople.org/adevs.spec
SRPM URL: http://jkaluza.fedorapeople.org/adevs-2.6-2.fc18.src.rpm

> [!]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses found:
>      "LGPL (v2 or later)", "LGPL (v2 or later) (with incorrect FSF address)",
>      "Unknown or generated". 306 files have unknown license. Detailed output
>      of licensecheck in /var/tmp/review/971244-adevs/licensecheck.txt
> 
> In the source code there are LGPLv2+, but the SPEC has GPLv2+

Fixed.

> [?]: If the source package does not include license text(s) as a separate
> file from upstream, the packager SHOULD query upstream to include it.
> 
> You could do it.

Asked upstream via email.

> I tried only to run the included tests, but they don't compile:
> g++ -fopenmp -g -pedantic -Wall -I../include atomic_test.cpp 
> In file included from ../include/adevs.h:30:0,
>                  from atomic_test.cpp:3:
> ../include/adevs_simulator.h: In instantiation of ‘void adevs::Simulator<X,
> T>::exec_event(adevs::Atomic<X, T>*, bool, T) [with X = char; T = double]’:
> ../include/adevs_simulator.h:338:3:   required from ‘void
> adevs::Simulator<X, T>::computeNextState(adevs::Bag<adevs::Event<X, T> >&,
> T) [with X = char; T = double]’
> atomic_test.cpp:118:32:   required from here
> ../include/adevs_simulator.h:620:2: error: ‘notify_state_listeners’ was not
> declared in this scope, and no declarations were found by argument-dependent
> lookup at the point of instantiation [-fpermissive]
> ../include/adevs_simulator.h:620:2: note: declarations in dependent base
> ‘adevs::AbstractSimulator<char, double>’ are not found by unqualified lookup
> ../include/adevs_simulator.h:620:2: note: use ‘this->notify_state_listeners’
> instead
> make: *** [atomic] Error 1

Caused by newer g++. Fixed in current srpm, patch sent upstream.

> [x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
> 
> Patch is not justified by comment, but it's purpose is clear. I think you
> could improve it a bit (i.e. conditionalize the modelica) and get it
> upstream.
> Also you don't need to comment out the OPTFLAG, just run 'make OPTFLAG=',
> the same for java, so you could stay more close to the upstream.

Fixed and sent upstream.

> [!]: %check is present and all tests pass.
> 
> You could run the tests.

Fixed.

> More comments:
> 
> CR + LF line ends in some files, e.g.: /src/Makefile and more
> 
> Please package doc and examples.
> 
> Could you run the tests?
> 
> There should be 'formalisms' instead of 'formalism' in the description as
> upstream has.
> 
> You could write in the description of the development package that it could
> be used for development or something similar. I think it is not good to have
> there the same description as the base package has.
> 
> You can add one more sentence to the desription (copy from the upstream
> description). 
> 
> Why openmp is not used? I think it can bring some performance gain and
> should be generally harmless.
> 
> Please do not mix macros and variables, i.e. $RPM_OPT_FLAGS and e.g.
> %{buildroot}. This is not against guidelines (IIRC), but you could be
> consistent, i.e. use %{optflags} instead of $RPM_OPT_FLAGS.
> 
> Please report the incorrect FSF address upstream.

All that should be done.

> You could also package java (if you want :).

I'm able to compile it, but I'm not able to test if it works. I have no problem with adding the support later when there will be actual need for it (it means when someone who needs adevs-java package (and who can test it) asks me to do it.)

> There is various bundled js code in /docs/api/jquery.js under various
> licenses that doesn't seem to be compatible with LGPLv2+ (this is currently
> not packaged, but could be as the doc).

This is mentioned in -docs subpackage license now.

Comment 4 Jaroslav Škarvada 2013-06-17 09:53:39 UTC
(In reply to Jan Kaluža from comment #3)
OK, thanks, please name the documentation  subpackage as 'doc', not 'docs':
http://fedoraproject.org/wiki/Packaging:Guidelines#Documentation

Also I would prefer all the docs to be placed in the directory:
/usr/share/doc/adevs

Comment 5 Jan Kaluža 2013-06-17 12:38:28 UTC
Spec URL: http://jkaluza.fedorapeople.org/adevs.spec
SRPM URL: http://jkaluza.fedorapeople.org/adevs-2.6-3.fc18.src.rpm

Should be fixed there ^.

Comment 6 Jaroslav Škarvada 2013-06-17 14:30:11 UTC
(In reply to Jan Kaluža from comment #5)
Thanks, giving it fedora review +.

Comment 7 Jan Kaluža 2013-06-17 14:36:10 UTC
New Package SCM Request
=======================
Package Name: adevs
Short Description: C++ library for constructing discrete event simulation
Owners: jkaluza
Branches: f18 f19
InitialCC:

Comment 8 Gwyn Ciesla 2013-06-17 16:21:28 UTC
Git done (by process-git-requests).

Comment 9 Fedora Update System 2013-06-18 11:53:43 UTC
adevs-2.6-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/adevs-2.6-4.fc19

Comment 10 Fedora Update System 2013-06-18 12:04:48 UTC
adevs-2.6-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/adevs-2.6-4.fc18

Comment 11 Fedora Update System 2013-06-18 19:39:36 UTC
adevs-2.6-4.fc19 has been pushed to the Fedora 19 testing repository.

Comment 12 Fedora Update System 2013-06-27 02:04:21 UTC
adevs-2.6-4.fc18 has been pushed to the Fedora 18 stable repository.

Comment 13 Fedora Update System 2013-06-29 18:13:58 UTC
adevs-2.6-4.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.